__rcs_id__ = """$Id: uDBSchemaMigration.py 303710 2007-08-01 14:19:05Z mkhon $"""
import uDBSchema, uPEM, uSysDB, uDBTypes
from uAction import *

def copyTable(name, con_from, con_to, name_mapping = None):
	if name_mapping and name_mapping.has_key(name):
		new_name = name_mapping[name]
	else:
		new_name = name
	progress.do("transferring table %s%s", name, new_name != name and (' to %s' % new_name) or '' )
	table = uDBSchema.getTable(name, con_from)
	constraints = table.constraints
	indexes = table.indexes
	table.constraints = []
	table.indexes = []
	table.name = new_name
	table.create(con_to)
	progress.do("transferring data")
	ordered_columns = table.columns[:]
	# BLOBS - should be at the end - because of MSSQL (TM) odbc driver
	ordered_columns.sort(lambda x, y: isinstance(x.type, uDBTypes.BlobType) - isinstance(y.type, uDBTypes.BlobType))
	columnstr = ", ".join(['"%s"' % c.name for c in ordered_columns])

	source_cur = con_from.cursor()
	target_cursor = con_to.cursor()

	have_identities = bool([c for c in table.columns if isinstance(c.type, uDBTypes.SerialType)])

	if have_identities:
		table.identityInsertBegin(con_to)
	source_cur.execute("SELECT %s FROM %s" % (columnstr, name))
	ins_query = "INSERT INTO %s (%s) VALUES (%s)" % (new_name, columnstr, ', '.join(['%s'] * len(table.columns)))
	row = source_cur.fetchone()
	while row:
		target_cursor.execute(ins_query, tuple(row))
		row = source_cur.fetchone()

	if have_identities:
		table.identityInsertEnd(con_to)
	
	progress.done()
	progress.do("creating constraints and indexes")
	for constr in constraints:
		if name_mapping and name_mapping.has_key(constr.name):
			constr.name = name_mapping[constr.name]
		if name_mapping and isinstance(constr, uDBSchema.ForeignKey) and constr.reftable in name_mapping:
                        constr.reftable = name_mapping[constr.reftable]
		table.addConstraint(constr, con_to)
	for ind in indexes:
		if name_mapping and name_mapping.has_key(ind.name):
			ind.name = name_mapping[ind.name]
		table.addIndex(ind, con_to)
	source_cur.close()
	target_cursor.close()
	progress.done()
	progress.done()


def fixProperties(plesk_con, sc_name):
	propnames = ('dsn', 'dsn_login', 'dsn_passwd')
	for propname in propnames:
		pval = uPEM.getSCProperty(plesk_con, "chief", propname)
		uPEM.setSCProperty(plesk_con, sc_name, propname, pval)
	
	uSysDB.init(connection=plesk_con)
