import uSysDB
import re
from pyPgSQL import PgSQL as pg
from uLogging import notice

def executeInCfgDb(sql):
	syscon = uSysDB.connect()
	syscur = syscon.cursor()

	#upgrade in configuration databases
	syscur.execute("SELECT DISTINCT ON (ahd.db_host_id, ahd.db_name) v_props.value, ahd.db_name, ahd.db_user, ahd.db_password FROM apache_h2e_db ahd JOIN components c ON ahd.db_host_id = c.host_id JOIN packages p USING (pkg_id) JOIN v_props USING (component_id) WHERE p.name = 'pleskd' AND v_props.name = 'communication.ip'")
	connections = []
	for host, dbname, dbuser, dbpassword in syscur.fetchall():
		host = re.sub('^0+', '', host)
		host = re.sub('[.]0{1,2}', '.', host)
		condb = pg.connect(host=host,user=dbuser,database=dbname,password=dbpassword)
		connections.append(condb)
		notice('uh2e ' + host + ' connected')

	for condb in connections:
		curdb = condb.cursor()
		curdb.execute(sql)
		notice('uh2e ' + condb.conn.host + ' executed')

	for condb in connections:
		condb.commit();
		notice('uh2e ' + condb.conn.host + ' commited')

